#This file deals with secant varieties of Grassmannians in their
#Pluecker embeddings. Compare the article of Geramita et al:
#`Secant varieties of Grassmann varieties'.

Read("sedimo.g");

for r in [1..8] do
	g:=SimpleLieAlgebra("A",r,Rationals);
	id:=IdentityMat(r,Rationals);
	i:=1; 
	while i<=(r+1)/2 do
		hw:=id[i];
		R:=InitialData(g,hw,Rationals);
		while R.dim[R.k] < R.n do 
			SecantDimension(R.k+1,R);; 
		od;
		Print("The (affine cone over the) Grassmannian of ",
		i,"-spaces in ",r+1, "-space has secant dimensions: \n",
		R.dim,"\n");
		i:=i+1;
	od;
od;

#output:
#The (affine cone over the) Grassmannian of 1-spaces in
#2-space has secant dimensions:
#[ 2 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#3-space has secant dimensions:
#[ 3 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#4-space has secant dimensions:
#[ 4 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#4-space has secant dimensions:
#[ 5, 6 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#5-space has secant dimensions:
#[ 5 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#5-space has secant dimensions:
#[ 7, 10 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#6-space has secant dimensions:
#[ 6 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#6-space has secant dimensions:
#[ 9, 14, 15 ]
#The (affine cone over the) Grassmannian of 3-spaces in
#6-space has secant dimensions:
#[ 10, 20 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#7-space has secant dimensions:
#[ 7 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#7-space has secant dimensions:
#[ 11, 18, 21 ]
#The (affine cone over the) Grassmannian of 3-spaces in
#7-space has secant dimensions:
#[ 13, 26, 34, 35 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#8-space has secant dimensions:
#[ 8 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#8-space has secant dimensions:
#[ 13, 22, 27, 28 ]
#The (affine cone over the) Grassmannian of 3-spaces in
#8-space has secant dimensions:
#[ 16, 32, 48, 56 ]
#The (affine cone over the) Grassmannian of 4-spaces in
#8-space has secant dimensions:
#[ 17, 34, 50, 64, 70 ]
#The (affine cone over the) Grassmannian of 1-spaces in
#9-space has secant dimensions:
#[ 9 ]
#The (affine cone over the) Grassmannian of 2-spaces in
#9-space has secant dimensions:
#[ 15, 26, 33, 36 ]
#The (affine cone over the) Grassmannian of 3-spaces in
#9-space has secant dimensions:
#[ 19, 38, 57, 74, 84 ]
#The (affine cone over the) Grassmannian of 4-spaces in
#9-space has secant dimensions:
#[ 21, 42, 63, 84, 105, 126 ]
