weylwordNF:= function( R, path )
        
    local   w,  rho,  wt;
        
    # the WeylWord in lex shortest form...
    w:= WeylWord( path );
    rho:= List( [1..Length( CartanMatrix(R))], x -> 1 );
    wt:= ApplyWeylElement( WeylGroup(R), rho, w );
    return ConjugateDominantWeightWithWord( WeylGroup(R), wt )[2];
end;


KostantBasis:= function( V )
     local   L,  R,  hw,  cg,  paths,  strings,  p,  p1, word, k, b,
st,  i,  j,  a,  y,  v,  bas, s1, i1, n1,  w,  sim, pos, posR, yy;


      L:= LeftActingAlgebra( V );
   R:= RootSystem( L );
   hw:= Basis(V)[1]![1]![1][1][3];

   cg:= CrystalGraph( R, hw );
   paths:= cg.points;
     # For every path we compute its adapted string.
     strings:= [ ];

      for p in paths do

           p1:= p;
           st:= [];

           word:= weylwordNF( R, p1 );
           while word <> [] do
               j:= 0;
               k:= word[1];
               while  WeylWord( p1 ) <> [] and word[1] = k do
                  p1:= Ealpha( p1, k );
                  word:= weylwordNF( R, p1 );     
                  j:= j+1;
               od;
               if j > 0 then
                   Add( st, k );
                   Add( st, j );
                fi;
           od;
           Add( strings, st );        
      od;  

     y:= ChevalleyBasis(L)[2];
   sim:= SimpleSystem( R );
   posR:= PositiveRoots( R );
   yy:= [];
   for a in sim do
       pos:= Position( posR, a );
       Add( yy, y[pos] );
   od;
   y:= yy;

      bas:= [ Basis(V)[1] ];
      for i in [2..Length(strings)] do
           s1:= ShallowCopy( strings[i] );
           i1:= s1[1];
           n1:= s1[2];
           if n1 > 1 then
              s1[2]:= n1-1;
           else
              Unbind( s1[1] ); Unbind( s1[2] );
              s1:= Filtered( s1, x -> IsBound(x) );
           fi;
           pos:= Position( strings, s1 );
           w:= bas[pos];
           w:= yy[i1]^w;
           w:= w/n1;
           Add( bas, w );
      od;

   return Basis( V, bas );
  end; 
